
InstanceItem = class( Turbine.UI.Control )

function InstanceItem:Constructor(width, data, heading, playerIndex, iniIndex)
	Turbine.UI.Control.Constructor( self )
	
	self.data = data
	self.heading = heading
	self:SetSize(width,(table.getn(data[1])*30)+40)
	self.Heading = Turbine.UI.Label()
	self.Heading:SetFont(FONTHEADING)
	self.Heading:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleLeft )
	self.Heading:SetParent(self)
	self.Heading:SetPosition(20,10)
	self.Heading:SetSize(width-40,20)
	self.Heading:SetText(heading)

	self.Boss = Turbine.UI.Label()
	self.Boss:SetFont(FONTHEADING)
	self.Boss:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleRight )
	self.Boss:SetParent(self)
	self.Boss:SetPosition(20,10)
	self.Boss:SetSize(width-40,20)
	
	self.ListBox = Turbine.UI.ListBox()
	self.ListBox:SetVisible(true)
	self.ListBox:SetParent(self)
	self.ListBox:SetPosition(30,40)
	self.ListBox:SetSize(self:GetWidth()-30,table.getn(data[1])*30)
	
	for k,bosses in ipairs(data[1]) do 
		self.ListBox:AddItem(RowItem(width, data, k, playerIndex, iniIndex))
	end
	
	function self.Boss:Update()
		
		local timeLeft = self.bossEnd-Turbine.Engine.GetGameTime()

		if timeLeft < 0 then
		
			self:SetText("")
			self:SetWantsUpdates(false)
		
		end
		
	end
	
	function self.ListBox.ChangeBossName(content)

		content = string.gsub(content, "'s", "")

		self.Boss.bossEnd = Turbine.Engine.GetGameTime()+5
		self.Boss:SetText(content)
		self.Boss:SetWantsUpdates(true)
		
	end

end



function InstanceItem:UpdateContent()

	for i=1, self.ListBox:GetItemCount(), 1 do
		
			self.ListBox:GetItem(i):UpdateContent()
		
	end

end

function InstanceItem:SizeChanged()

	if self.ListBox then

		self.ListBox:SetWidth(self:GetWidth()-30)
		self.Heading:SetWidth(self:GetWidth()-100)
		self.Boss:SetWidth(self:GetWidth()-40)

		for i=1, self.ListBox:GetItemCount(), 1 do
		
			self.ListBox:GetItem(i):SetWidth(self.ListBox:GetWidth())
		
		end
	end

end