
RowItem = class( Turbine.UI.Control )

function RowItem:Constructor(width, data, tier, playerIndex, iniIndex)
	Turbine.UI.Control.Constructor( self )

	self.data = data
	self.tier = tier
	self.playerIndex = playerIndex
	self.iniIndex = iniIndex
	
	self:SetSize(width,30)
	
	self.bg = Turbine.UI.Control()
	self.bg:SetParent(self)
	self.bg:SetBackColor(Turbine.UI.Color(0.3,0.3,0.3))
	self.bg:SetOpacity(0.1)
	self.bg:SetSize(self:GetWidth()-4, self:GetHeight()-4)
	self.bg:SetPosition(2,2)
	
	self.Text = Turbine.UI.Label()
	self.Text:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleLeft )
	self.Text:SetMouseVisible(false)
	self.Text:SetFontStyle(Turbine.UI.FontStyle.Outline)
	self.Text:SetFont(FONT)
	self.Text:SetParent(self)
	self.Text:SetPosition(15,5)
	self.Text:SetSize(width,25)

	self.listBox = Turbine.UI.ListBox()
	self.listBox:SetVisible(true)
	self.listBox:SetParent(self)
	self.listBox:SetOrientation( Turbine.UI.Orientation.Horizontal )
	self.listBox:SetPosition(102,2)
	self.listBox:SetSize(self:GetWidth()-304,self:GetHeight()-4)

	self.Resettime = Turbine.UI.Label()
	self.Resettime:SetFontStyle(Turbine.UI.FontStyle.Outline)
	self.Resettime:SetMouseVisible(false)
	self.Resettime:SetFont(FONT)
	self.Resettime:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleRight )
	self.Resettime:SetParent(self)
	self.Resettime:SetPosition(200,5)
	self.Resettime:SetSize(self:GetWidth()-230,25)

	
	self:UpdateContent()

end

function RowItem:CreateLBItem(content, name)
	
	local item = Turbine.UI.Control()
	item:SetSize(46,26)
	
	item.name = name
	
	item.label = Turbine.UI.Label()
	
	item.label:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleCenter )
	item.label:SetPosition(2,2)
	item.label:SetMouseVisible(true)
	item.label:SetParent(item)
	item.label:SetFontStyle(Turbine.UI.FontStyle.Outline)
	item.label:SetFont(FONT)
	item.label:SetSize(46,26)
	item.label:SetText(content)

	function item.label.MouseEnter(sender, args)
		self:GetParent().ChangeBossName(item.name)
	end
	
	return item

end

function RowItem:UpdateResetTime()

	local reset

	for i=1, table.getn(self.data), 1 do
	
		if(self.data[i][self.tier]["nextReset"] ~= 0) then
			
			reset = self.data[i][self.tier]["nextReset"]
		
		end	
	
	end
	
	if reset ~= nil then
	
		reset = (reset-Turbine.Engine.GetGameTime())/3600

		local resetString = (math.floor(reset/24))
		reset = reset-(resetString*24)
		resetString = resetString.."d - "..math.floor(reset).."h  "	
		self.Resettime:SetText(resetString)		
	
	else
	
		self.Resettime:SetText("")	
	
	end
	
end

function RowItem:SizeChanged()
	
	if self.Resettime then
	
		self.Resettime:SetWidth(self:GetWidth()-200)
		self.bg:SetWidth(self:GetWidth()-4)
		self.listBox:SetSize(self:GetWidth()-150,30) 
		
	end

end


function RowItem:UpdateContent()

	self.Text:SetText(Instances[self.iniIndex][1][self.tier]["name"])
	
	self.listBox:ClearItems()

	local firstValue = tostring(self.data[1][self.tier]["amount"])
	local counter = 0
	local lowest = 99
	
	for k,bosses in ipairs(self.data) do 

		local amount = bosses[self.tier]["amount"]

		self.listBox:AddItem(self:CreateLBItem(amount, Instances[self.iniIndex][k]["clearName"]))

			if 'number' == type(amount) then
				if amount < lowest then
					lowest = amount
				end
			end

			if firstValue == tostring(amount) then
				counter = counter+1
			end

		
	end
	
	if counter == table.getn(self.data) then
	
		if firstValue == "0" then
			self.bg:SetBackColor(Turbine.UI.Color(0.4,0,0))
		elseif firstValue == "-" then
			self.bg:SetBackColor()
		else	
		
			if lowest > 0 then
				self.bg:SetBackColor(Turbine.UI.Color(0.4,0.4,0))
			elseif lowest < 0 then
				self.bg:SetBackColor(Turbine.UI.Color(0.4,0.3,0))
			else
				self.bg:SetBackColor(Turbine.UI.Color(0.4,0.2,0))
			end
		
			
		end
	
	else
	
		if lowest > 0 then
				self.bg:SetBackColor(Turbine.UI.Color(0.4,0.4,0))
			elseif lowest < 0 then
				self.bg:SetBackColor(Turbine.UI.Color(0.4,0.3,0))
			else
				self.bg:SetBackColor(Turbine.UI.Color(0.4,0.2,0))
			end
	
	end

	self:UpdateResetTime()
end
