
LogWindow = class( Turbine.UI.Lotro.Window )

function LogWindow:Constructor()
	Turbine.UI.Lotro.Window.Constructor( self )
	
	CheckForReset()
	
	self:SetVisible(true)
	self:SetText("LootLogs")
	self:SetSize(LootSettings["window"]["width"],LootSettings["window"]["height"])
	self:SetPosition(LootSettings["window"]["left"],LootSettings["window"]["top"])
	self:SetResizable(true)
	self:SetMinimumWidth(520)

	self.charackterSelect = LabelledComboBox(nil, nil, 150)
	self.charackterSelect:SetParent(self)
	self.charackterSelect:SetPosition(40,50)
	
	self.instanceSelect = LabelledComboBox(nil, nil, 300)
	self.instanceSelect:SetParent(self)
	self.instanceSelect:SetPosition(210,50)
	
	self.clearButton = Turbine.UI.Lotro.Button()
	self.clearButton:SetVisible(true)
	self.clearButton:SetParent(self)
	self.clearButton:SetPosition(self:GetWidth()-150,50)
	self.clearButton:SetSize(100,25)
	self.clearButton:SetText("Clear")
	
	function self.clearButton:Click()

		for i,players in ipairs(LootList) do 

			for j,inis in ipairs(players["loot"]) do 
				inis["show"] = false
				for k,bosses in ipairs(inis) do 

					for m,tiers in ipairs(bosses) do 

						tiers["amount"] = "-"
						tiers["nextReset"] = 0
		
					end
		
				end
		
			end
		
		end
		
		SaveLogs()
		self:GetParent():UpdateContent()

	end

	self.ListBox = Turbine.UI.ListBox()
	self.ListBox:SetParent(self)	
	self.ListBox:SetPosition(30,100)
	self.ListBox:SetSize(self:GetWidth()-60,self:GetHeight()-130)
	self.ListBox:Sort(function(elem1,elem2) if elem1.heading>elem2.heading then Turbine.Shell.WriteLine("here") return true end end)
	self.Scroll = Turbine.UI.Lotro.ScrollBar()
	self.Scroll:SetOrientation(Turbine.UI.Orientation.Vertical)
	self.Scroll:SetParent(self.ListBox)
	self.Scroll:SetPosition(self.ListBox:GetWidth()-12,0)
	self.Scroll:SetWidth(12)
	self.Scroll:SetHeight(self.ListBox:GetHeight())
	self.ListBox:SetVerticalScrollBar(self.Scroll)

	self:UpdateContent()
	
	
end



function LogWindow:Closed(sender, args)

	showIcon()

end

function LogWindow:FillSelected(value)

	if value == nil then
		value = self.charackterSelect:GetSeletion()
	end

	self.ListBox:ClearItems()
	
	if value > 0 then

		for k,ini in ipairs(LootList[value]["loot"]) do 
			if ini["show"] then
				self.ListBox:AddItem(InstanceItem(self.ListBox:GetWidth()-12, ini, ini["name"], value, k))
				self.ListBox:Sort(function(elem1,elem2) if elem1.heading<elem2.heading then return true end end)
			end
		end
		self.instanceSelect:SetSelection(nil)
		
	elseif value < 0 then
	
		value = value*(-1)
		
		for i,player in ipairs(LootList) do 

			if player["loot"][value]["show"] then
			
				self.ListBox:AddItem(InstanceItem(self.ListBox:GetWidth()-12, player["loot"][value], player["player"], i, value))
				self.ListBox:Sort(function(elem1,elem2) if elem1.heading<elem2.heading then return true end end)
			end
	
		end
		self.charackterSelect:SetSelection(nil)
		
	else
	
		self.charackterSelect:SetSelection(currentIndex)
		self.instanceSelect:SetSelection(0)
		self:FillSelected(currentIndex)
	end

end

function LogWindow:UpdateContent()

	self.instanceSelect:Clear()
	local index = 1
	for i,ini in ipairs(Instances) do 
		self.instanceSelect:AddItem(ini["name"], i*(-1), index)
	index = index+1
	end

	index = index
	self.charackterSelect:Clear()	
	for k,player in ipairs(LootList) do 
		self.charackterSelect:AddItem(player["player"], k, index)
		index = index+1
	end
	
	
	
	self.charackterSelect:SetSelection(currentIndex)
	self:FillSelected(currentIndex)

end

function LogWindow:PositionChanged()

	LootSettings["window"]["left"], LootSettings["window"]["top"]  = self:GetPosition()

	
	SaveSettings()

end

function LogWindow:SizeChanged()

	self.ListBox:SetSize(self:GetWidth()-60,self:GetHeight()-130)
	self.Scroll:SetPosition(self.ListBox:GetWidth()-12,0)
	self.Scroll:SetHeight(self.ListBox:GetHeight())
	self.clearButton:SetLeft(self:GetWidth()-150)
	
	for i=1, self.ListBox:GetItemCount(), 1 do
	
		self.ListBox:GetItem(i):SetWidth(self.ListBox:GetWidth()-12)
	
	end
	
	LootSettings["window"]["width"],LootSettings["window"]["height"] = self:GetSize()
	
	SaveSettings()

end
